#ifndef SCHEDULER_CONFIG_H
#define SCHEDULER_CONFIG_H
/************************************************************************************************************
 * (c) Triple-S GmbH 2012
 ************************************************************************************************************/
/*****************************************************************************
*   $Logfile: /SOURCE/Scheduler_config.h $
*   $Revision: 1 $
*   $Author: Scheduler.x2x $
*   $Date: 2012.11.28 13:13:08 $
*
*    Project:                   TEST
*
*    Content:                   Konfigurationsdatei fr das Modul Scheduler
*
*
*
*    Author(s):                 Scheduler.x2x
*
*****************************************************************************/

/*****************************************************************************
*
* CHANGE LOG:
*
* Date     Name Change description
* -----------------------------------------------------------------
*
*****************************************************************************/
#if !defined SCHEDULER_C
#else
/*---- Module relavant configurations (privat) -----------------------------*/

/*includes for configuration*/
#include "Fr.h"
#include "Can.h"
#include "Com.h"
#include "System.h"


/***********************************************************************/
/* list here all functions called within a specific time slice */
/***********************************************************************/
/* list all functions that must be called befor all time slices */
#define BEGIN_TIMESLICE()  \
        System_Startup( ); 
/* end of #define BEGIN_TIMESLICE() */

/* list all functions that must be called after all time slices */
#define END_TIMESLICE()  \
        System_Shutdown( ); 
/* end of #define END_TIMESLICE() */

/* 5ms ********************************************************************************************************************/
#define CYCLIC_BASEx1x1() \
        TIME_SLICE_CALL( Can_MainFunction_Write );  \
        TIME_SLICE_CALL( Can_MainFunction_Read );  \
        TIME_SLICE_CALL( FrIf_MainFunction_0 );  \
        TIME_SLICE_CALL( LinIf_MainFunction );  \
        TIME_SLICE_CALL( CanNm_MainFunction );  \
        TIME_SLICE_CALL( FrNm_MainFunction_0 );  \
        TIME_SLICE_CALL( CanSM_MainFunction );  \
        TIME_SLICE_CALL( FrSM_MainFunction_0 );  \
        TIME_SLICE_CALL( FrTp_MainFunction );  \
        TIME_SLICE_CALL( CanTp_MainFunction );  \
        TIME_SLICE_CALL( Com_MainFunctionRx );  \
        TIME_SLICE_CALL( Com_MainFunctionRouteSignals );  \
        TIME_SLICE_CALL( Com_MainFunctionTx ); 
/* end of #define CYCLIC_BASEx1x1() */

/* 10ms ********************************************************************************************************************/
#define CYCLIC_BASEx1x2() \
        TIME_SLICE_CALL( LinSM_MainFunction );  \
        TIME_SLICE_CALL( Xcp_MainFunction );  \
        TIME_SLICE_CALL( Can_MainFunction_Mode );  \
        TIME_SLICE_CALL( Fee_MainFunction );  \
        TIME_SLICE_CALL( NvM_MainFunction );  \
        TIME_SLICE_CALL( CddTpms_MainFunction );  \
        TIME_SLICE_CALL( EcuM_MainFunction );  \
        TIME_SLICE_CALL( Run_ExteriorLight_Sensor );  \
        TIME_SLICE_CALL( Run_TirePMon_Cyclic ); 
/* end of #define CYCLIC_BASEx1x2() */

/* 20ms ********************************************************************************************************************/
#define CYCLIC_BASEx1x4() \
        TIME_SLICE_CALL( Run_InteriorLight_Actuator );  \
        TIME_SLICE_CALL( Run_InteriorLight_Sensor );  \
        TIME_SLICE_CALL( Run_SoundSignaling_Sensor );  \
        TIME_SLICE_CALL( Run_SoundSignaling_Actuator );  \
        TIME_SLICE_CALL( Run_HornMgr_Step ); 
/* end of #define CYCLIC_BASEx1x4() */

/* 40ms ********************************************************************************************************************/
#define CYCLIC_BASEx1x8() \
        TIME_SLICE_CALL( Run_SoundSignaling_Step );  \
        TIME_SLICE_CALL( Run_InteriorLight_Step ); 
/* end of #define CYCLIC_BASEx1x8() */

/* 50ms ********************************************************************************************************************/
#define CYCLIC_BASEx5x2() \
        TIME_SLICE_CALL( Run_ComCtrl_Handler );  \
        TIME_SLICE_CALL( Run_AntiTheftProtection_Sensor );  \
        TIME_SLICE_CALL( Run_AlrmMgr_Step ); 
/* end of #define CYCLIC_BASEx5x2() */

/* 100ms ********************************************************************************************************************/
#define CYCLIC_BASEx5x4() \
        TIME_SLICE_CALL( ComCtrl_TimeoutCheck_Run );  \
        TIME_SLICE_CALL( Run_LowVoltage_Sensor ); 
/* end of #define CYCLIC_BASEx5x4() */

/* 200ms ********************************************************************************************************************/
#define CYCLIC_BASEx5x8() \
        TIME_SLICE_CALL( Run_MirrTintgMgr_Step );  \
        TIME_SLICE_CALL( Run_DstBkpInBody_Step );  \
        TIME_SLICE_CALL( Run_HdlmpMon_Step ); 
/* end of #define CYCLIC_BASEx5x8() */

/* 125ms ********************************************************************************************************************/
#define CYCLIC_BASEx25x1() \
        TIME_SLICE_CALL( ComCtrl_CarCfg_Run ); 
/* end of #define CYCLIC_BASEx25x1() */

/* 250ms ********************************************************************************************************************/
#define CYCLIC_BASEx25x2() \
        TIME_SLICE_CALL( ComCtrl_VIN_Run ); 
/* end of #define CYCLIC_BASEx25x2() */

/* 500ms ********************************************************************************************************************/
#define CYCLIC_BASEx25x4() \
        TIME_SLICE_CALL( Run_BattMgr_Step );  \
        TIME_SLICE_CALL( Run_PowerCheck_Step ); 
/* end of #define CYCLIC_BASEx25x4() */

/* 1000ms ********************************************************************************************************************/
#define CYCLIC_BASEx25x8() \
        TIME_SLICE_CALL( Run_CarCfgDet_Step );  \
        TIME_SLICE_CALL( Run_SteerColCtrl_Step ); 
/* end of #define CYCLIC_BASEx25x8() */

#endif // #else #if !defined _Scheduler_CFG_

#endif // #ifndef SCHEDULER_CONFIG_H

